
local GLUESIG = "%%glue:L"
local stub = nil

local function checkexe()
  if arg[0]:sub(-4, -1) == ".exe" then
    local sfile = io.open(arg[0], "rb")
    if sfile then
      sfile:seek("end", -(8 + #GLUESIG))
      if GLUESIG == sfile:read(#GLUESIG) then
        local stublen = (string.byte(sfile:read(1))) +
                        (string.byte(sfile:read(1)) * 256) +
                        (string.byte(sfile:read(1)) * 256^2) +
                        (string.byte(sfile:read(1)) * 256^3);
        sfile:seek("set", 0)
        stub = sfile:read(stublen)
        sfile:close()
        if stub then 
          return true 
        end
      end
    end
  end
  print("error: no srlua.exe found. aborting..")
  os.exit()
end

local function linteger(num)
  local function byte(n)
    return math.floor(num / (256^n)) % 256
  end
  return string.char(byte(0),byte(1),byte(2),byte(3))
end

local function glue(ifilename, ofilename)
  ofilename = ofilename or ifilename .. ".exe"
  local ifile = io.open(ifilename, "rb")
  if not ifile then
    print("error: cant open '" .. ifilename .. "'.")
    os.exit()
  end
  local luafile = ifile:read("*a")
  ifile:close()
  local ofile = io.open(ofilename, "wb")
  ofile:write(stub)
  ofile:write(luafile)
  ofile:write(GLUESIG)
  ofile:write(linteger(#stub))
  ofile:write(linteger(#luafile))
  ofile:close()
  print(ofilename .. " written.")
end

if #arg == 1 or #arg == 2 then
  checkexe()
  glue(arg[1], arg[2])
else
  local preloaded = ""
  for n, _ in pairs(package.preload) do
    preloaded = preloaded .." "..n
  end
  print("glue V14/02/08\n\z
  - syntax: glue <luafile> [<exefile>]\n\z
  - preloaded modules: " .. preloaded
  )
end
